Unit MyDiskIO;    {Laurie's Absolute disk read/write stuff}
{  13/11/2004  I finally wrote this to implement UNITREAD/UNITWRITE    }
{              for the I.5 interp.  I've put this off for years and I  }
{              did not want to write it....I tried it once and stuffed }
{              a complete hard disk of DATA (CP/M, turbo 2, on Apple///}


{ Remember that with Int25 and Int26 we are delaing with logical sectors }
{ Pass $FFFF in CX, pass a structure of type PDISKBLOCK in DX:BS.        }
{ If carry is set then you got an error                                  }
{ Use this at your own risk.                                             }
{ Based on code DISKINF3 that I found on the net.                        }
{ Laurie Boshell 47 Martin Place LINDEN NSW Australia                    }
INTERFACE
const
  DriveA = 0;
  DriveB = 1;
  DriveC = 2;
  DriveD = 3;   {and so no....}

type
  PBootSec = ^TBootSec;
  TBootSec = record
    Signature         : Byte;
    Skip              : Word;
    Vendor            : Array[1..8] of Char;
    BytesPerSector    : Word;
    SecPerClus        : Byte;
    ReservedSectors   : Word;
    FatCopies         : Byte;
    RootEntries       : Word;
    TotalSectors      : Word;
    Media             : Byte;
    SecPerFat         : Word;
    SectorsPerTrack   : Word;
    Heads             : Word;
    HiddenSectors     : Word;
    Loader            : Array[1..482] of Byte;
  end;

  PDiskBlock = ^TDiskBlock;
  TDiskBlock = Record
    SectNumber: LongInt;
    NumSectors: Word;
    Buffer: PBootSec;
  end;

  TSector = Array[0..511] of byte;
  pBuf = ^ TSector;
var
  DiskBlock :PDiskBlock;

Function MyReadDisk(Drive: Byte; SNum,Len: Integer; Buf: pBuf):integer;
Function MyWriteDisk(Drive: Byte; SNum,Len: Integer; Buf: pBuf):integer;
IMPLEMENTATION

procedure WriteHexWord(w: Word);
const
 hexChars: array [0..$F] of Char =
   '0123456789ABCDEF';
begin
 Write(hexChars[Hi(w) shr 4],
       hexChars[Hi(w) and $F],
       hexChars[Lo(w) shr 4],
       hexChars[Lo(w) and $F]);
end;

procedure WriteHexByte(B: Word);
const
 hexChars: array [0..$F] of Char =
   '0123456789ABCDEF';
begin
  Write(hexChars[b shr 4], hexChars[b and $F]);
end;

procedure WriteBoot(var Buf: PDiskBlock);
var
  SecRead: TBootSec;
  i: Integer;
begin
  Move(Buf^.Buffer^, SecRead, 512);
  with SecRead do begin
    WriteLn('Signature = ', Buf^.Buffer^.Signature);
    Write('Vendor = ');
    for i := 1 to 8 do Write(Vendor[i]); WriteLn;
    WriteLn('Bytes Per Sector = ', BytesPerSector);
    WriteLn('Sectors Per Cluster = ', SecPerClus);
    WriteLn('Fat copies: ', FatCopies);
    WriteLn('Root Entries: ', RootEntries);
    WriteLn('Total Sectors = ', TotalSectors);
    WriteLn('Media = ', Media);
    WriteLn('Sec Per Fat = ', SecPerFat);
    WriteLn('Sectors Per Track = ', SectorsPerTrack);
    WriteLn('Heads = ', Heads);
    WriteLn('Hidden Sectors = ', HiddenSectors);
  end;
end;

procedure WriteHardDisk(DiskBlock: PDiskBlock; Drive: Byte; SNum: Integer);
begin
halt;
  DiskBlock^.SectNumber := SNum;
  DiskBlock^.NumSectors := 1;
  asm
    push ds
    mov al, Drive
    mov cx, $FFFF
    lds BX, DiskBlock;
    int $26
    add sp, 2
    pop ds
  end;
end;

Function MyReadDisk(Drive: Byte; SNum,Len: Integer; Buf: pBuf):integer;
{Return 0 id success, 1 if fail}
var Areg:word;
begin
  DiskBlock^.SectNumber := SNum;
  DiskBlock^.NumSectors := Len DIV 512{1};
  pBuf(DiskBlock^.Buffer) := Buf;    {point at the caller's buffer}
                                     {use a type cast pBuf() to keep compiler happy}
  asm
    push ds
    mov al, Drive
    mov cx, $FFFF
    lds BX, DiskBlock;
    int $25
    POP AX         {Was add  sp,2}
    POP DS
    jc  @fail
    MOV ax,0
    jmp @done
@fail:
    MOV ax,4   {Undefined hardware error in UCSD I.5}
@done:
     MOV Areg,ax
  end;

  MyReadDisk := Areg;
end;


Function MyWriteDisk(Drive: Byte; SNum,Len: Integer; Buf: pBuf):integer;
{Return 0 id success, 1 if fail}
var Areg:word;
begin
  DiskBlock^.SectNumber := SNum;
  DiskBlock^.NumSectors := Len DIV 512;
  pBuf(DiskBlock^.Buffer) := Buf;    {point at the caller's buffer}
                                     {use a type cast pBuf() to keep compiler happy}
  asm
    push ds
    mov al, Drive
    mov cx, $FFFF
    lds BX, DiskBlock;
    int $26
    POP AX
    POP DS
    jc  @fail
    MOV ax,0
    jmp @done
@fail:
    MOV ax,4   {Undefined hardware error in UCSD I.5}
@done:
     MOV Areg,ax
  end;

  MyWriteDisk := Areg;
end;




procedure ReadHardDisk(DiskBlock: PDiskBlock; Drive: Byte; SNum: Integer);
var Areg:word;
begin
  DiskBlock^.SectNumber := SNum;
  DiskBlock^.NumSectors := 1;
  asm
    push ds
    mov al, Drive
    mov cx, $FFFF
    lds BX, DiskBlock;
    int $25
    jc  @fail
    MOV ax,0
    jmp @done
@fail:
    MOV ax,1

@done:

    MOV Areg,ax
    add sp, 2
    pop ds
  end;
  writeln(areg);
end;

procedure Write128Bytes(DiskBlock: PDiskBlock; Start, Stop: Integer);
type
  PArray = ^TArray;
  TArray = array[1..512] of Byte;
var
  i: Integer;
  S: String;
begin
  S[0] := #16;
  for i := Start to Stop do begin
    WriteHexByte(PArray(DiskBlock^.Buffer)^[i]);
    Write(' ');
    if i mod 16 = 0 then begin
      Write('   ');
      move(PArray(DiskBlock^.Buffer)^[i - 16], S[1], 16);
      Write(s); {      WriteStr(WhereX, WhereY, S, 15 + 1 * 16);}
      WriteLn;
    end;
  end;
end;

procedure WriteDiskInfo(DiskBlock: PDiskBlock);
var
  i, Start, Stop: Integer;
begin
  Start := 1;
  Stop := 128;
  for i := 1 to 4 do begin
    Write128Bytes(DiskBlock, Start, Stop);
    Inc(Start, 128);
    Inc(Stop, 128);
    WriteLn;
    ReadLn;
  end;
end;



begin
  New(DiskBlock);
  New(DiskBlock^.Buffer);
end.