
{ UCSD Globals from I.5 patched for turbo.  Designed for the interpreter    }
{ written in pascal.  Taken from globals of OS for I.5, a few hacks to make }
{ turbo occupy same memory sizes, but no other changes.                   LB}

{PROGRAM PASCALSYSTEM;}
unit ucsdglbu;     {descended from (similar to) include file ucsdglob.pas LB}
INTERFACE
(************************************************)
(*						*)
(*    UCSD PASCAL OPERATING SYSTEM		*)
(*						*)
(*    RELEASE LEVEL:  I.3   AUGUST, 1977	*)
(*                    I.4   JANUARY, 1978	*)
(*		      I.5   SEPTEMBER, 1978	*)
(*						*)
(*    WRITTEN BY ROGER T. SUMNER		*)
(*    WINTER 1977				*)
(*						*)
(*    INSTITUTE FOR INFORMATION SYSTEMS		*)
(*    UC SAN DIEGO, LA JOLLA, CA		*)
(*						*)
(*    KENNETH L. BOWLES, DIRECTOR		*)
(*						*)
(************************************************)
CONST
     MMAXINT  = 32767;	(*MAXIMUM INTEGER VALUE*)
     MAXUNIT  = 12;	(*MAXIMUM PHYSICAL UNIT # FOR UREAD*)
     MAXDIR   = 77;	(*MAX NUMBER OF ENTRIES IN A DIRECTORY*)
     VIDLENG  = 7;	(*NUMBER OF CHARS IN A VOLUME ID*)
     TIDLENG  = 15;	(*NUMBER OF CHARS IN TITLE ID*)
     MAXSEG   = 15;	(*MAX CODE SEGMENT NUMBER*)
     FBLKSIZE = 512;	(*STANDARD DISK BLOCK LENGTH*)
     DIRBLK   = 2;	(*DISK ADDR OF DIRECTORY*)
     AGELIMIT = 300;	(*MAX AGE FOR GDIRP...IN TICKS*)
     EOL      = 13;	(*END-OF-LINE...ASCII CR*)
     DLE      = 16;	(*BLANK COMPRESSION CODE*)


     {patch for IORSLTWD}
     INOERROR  =  0;
     IBADBLOCK =  1;
     IBADUNIT  =  2;
     IBADMODE  =  3;
     ITIMEOUT  =  4;
     ILOSTUNIT =  5;
     ILOSTFILE =  6;
     IBADTITLE =  7;
     INOROOM   =  8;
     INOUNIT   =  9;
     INOFILE   = 10;
     IDUPFILE  = 11;
     INOTCLOSED= 12;
     INOTOPEN  = 13;
     IBADFORMAT= 14;
     ISTRGOVFL = 15;



     {patch for CMDSTATE}
     HALTINIT  =  0;
     DEBUGCALL =  1;
     UPROGNOU  =  2;
     UPROGUOK  =  3;
     SYSPROG   =  4;
     COMPONLY  =  5;
     COMPANDGO =  6;
     COMPDEBUG =  7;
     LINKANDGO =  8;
     LINKDEBUG =  9;


     {patch for FILEKIND}
     UNTYPEDFILE= 0;
     XDSKFILE  =  1;
     CODEFILE  =  2;
     TEXTFILE  =  3;
     INFOFILE  =  4;
     DATAFILE  =  5;
     GRAFFILE  =  6;
     FOTOFILE  =  7;
     SECUREDIR =  8;

{interp 1.5 (Z80) constants}
     Nill      =  0;  {1 on z80/68000, 0 on apple}
     {MaxSeg   = 15;} {already defined above}
     MSCWSize  = 12;  {size of mark stack control word}
     DISP0     = 10;  {offset from MSSTAT of variable w/ offset 0}


TYPE

     IORSLTWD = integer; (*
                 (INOERROR,IBADBLOCK,IBADUNIT,IBADMODE,ITIMEOUT,
		 ILOSTUNIT,ILOSTFILE,IBADTITLE,INOROOM,INOUNIT,
		 INOFILE,IDUPFILE,INOTCLOSED,INOTOPEN,IBADFORMAT,
		 ISTRGOVFL); *)

     (*COMMAND STATES...SEE GETCMD*)

     CMDSTATE = integer; (*
                 (HALTINIT,DEBUGCALL,
		 UPROGNOU,UPROGUOK,SYSPROG,
		 COMPONLY,COMPANDGO,COMPDEBUG,
		 LINKANDGO,LINKDEBUG); *)

     (*ARCHIVAL INFO...THE DATE*)

     DATEREC = integer;
                {
                PACKED RECORD
		 MONTH: 0..12;		(*0 IMPLIES DATE NOT MEANINGFUL*)
		 DAY: 0..31;		(*DAY OF MONTH*)
		 YEAR: 0..100		(*100 IS TEMP DISK FLAG*)
		END (*DATEREC*) ;
                }

					(*VOLUME TABLES*)
     UNITNUM = integer; {0..MAXUNIT;}
     VID = STRING[VIDLENG];

					(*DISK DIRECTORIES*)
     DIRRANGE = integer; {0..MAXDIR;}
     TID      = STRING[TIDLENG];

     FILEKIND = integer; (*
                 (UNTYPEDFILE,XDSKFILE,CODEFILE,TEXTFILE,
		 INFOFILE,DATAFILE,GRAFFILE,FOTOFILE,SECUREDIR); *)

     DIRENTRY = RECORD
		  DFIRSTBLK: INTEGER;	(*FIRST PHYSICAL DISK ADDR*)
		  DLASTBLK: INTEGER;	(*POINTS AT BLOCK FOLLOWING*)
		  CASE DFKIND: FILEKIND OF
		    SECUREDIR,
		    UNTYPEDFILE: (*ONLY IN DIR[0]...VOLUME INFO*)
			 (DVID: VID;		(*NAME OF DISK VOLUME*)
			DEOVBLK: INTEGER;	(*LASTBLK OF VOLUME*)
			DNUMFILES: DIRRANGE;	(*NUM FILES IN DIR*)
			DLOADTIME: INTEGER;	(*TIME OF LAST ACCESS*)
			DLASTBOOT: DATEREC);	(*MOST RECENT DATE SETTING*)
		    XDSKFILE,CODEFILE,TEXTFILE,INFOFILE,
		    DATAFILE,GRAFFILE,FOTOFILE:
			 (DTID: TID;		(*TITLE OF FILE*)
			DLASTBYTE: 1..FBLKSIZE;	(*NUM BYTES IN LAST BLOCK*)
			DACCESS: DATEREC)	(*LAST MODIFICATION DATE*)
		END (*DIRENTRY*) ;

     DIRP     = ^DIRECTORY;

     DIRECTORY= ARRAY [0..maxdir{DIRRANGE}] OF DIRENTRY;

					(*FILE INFORMATION*)

     CLOSETYPE= (CNORMAL,CLOCK,CPURGE,CCRUNCH);
     WINDOWP  = ^WINDOW;
     WINDOW   = PACKED ARRAY [0..0] OF CHAR;
     FIBP     = ^FIB;

     FIB = RECORD
	     FWINDOW: WINDOWP;	(*USER WINDOW...F^, USED BY GET-PUT*)
	     FEOF,FEOLN: BOOLEAN;
	     FSTATE: (FJANDW,FNEEDCHAR,FGOTCHAR);
	     FRECSIZE: INTEGER;	(*IN BYTES...0=>BLOCKFILE, 1=>CHARFILE*)
	     CASE FISOPEN: BOOLEAN OF
		TRUE: (FISBLKD: BOOLEAN;  (*FILE IS ON BLOCK DEVICE*)
			FUNIT: UNITNUM;	  (*PHYSICAL UNIT #*)
			FVID: VID;	  (*VOLUME NAME*)
			FREPTCNT,	  (* # TIMES F^ VALID W/O GET*)
			FNXTBLK,	  (*NEXT REL BLOCK TO IO*)
			FMAXBLK: INTEGER; (*MAX REL BLOCK ACCESSED*)
			FMODIFIED:BOOLEAN;(*PLEASE SET NEW DATE IN CLOSE*)
			FHEADER: DIRENTRY;(*COPY OF DISK DIR ENTRY*)
			CASE FSOFTBUF: BOOLEAN OF (*DISK GET-PUT STUFF*)
			TRUE: (FNXTBYTE,FMAXBYTE: INTEGER;
				  FBUFCHNGD: BOOLEAN;
				  FBUFFER: PACKED ARRAY [0..FBLKSIZE] OF CHAR))
	   END (*FIB*) ;

					(*USER WORKFILE STUFF*)

     INFOREC = RECORD
		 CODEFIBP: FIBP;	(*WORKFILES FOR SCRATCH*)
		 SYMFIBP : FIBP;
                 ERRNUM  : INTEGER;	(*ERROR STUFF IN EDIT*)
		 ERRBLK  : integer;
                 ERRSYM  : integer;
                 STUPID  : BOOLEAN;	(*STUDENT PROGRAMMER ID!!*)
		 SLOWTERM: Boolean;
                 ALTMODE : CHAR;			(*WASHOUT CHAR FOR COMPILER*)
		 GOTCODE : BOOLEAN;	(*TITLES ARE MEANINGFUL*)
		 GOTSYM  : Boolean;
                 CODEVID : VID;	(*PERM&CUR WORKFILE VOLUMES*)
		 SYMVID  : Vid;
                 WORKVID : Vid;
                 CODETID : TID;	(*PERM&CUR WORKFILES TITLE*)
                 SYTID   : Tid;
                 Worktid : Tid;
		END (*INFOREC*) ;

					(*CODE SEGMENT LAYOUTS*)

     SEGRANGE = 0..MAXSEG;
     SEGDESC = RECORD
		 DISKADDR: INTEGER;	(*REL BLK IN CODE...ABS IN SYSCOM^*)
		 CODELENG: INTEGER	(*# BYTES TO READ IN*)
		END (*SEGDESC*) ;

					(*DEBUGGER STUFF*)

     BYTERANGE = 0..255;
     TRICKARRAY = ARRAY [0..0] OF INTEGER; (* FOR MEMORY DIDDLING*)
     MSCWP = ^ MSCW;		(*MARK STACK RECORD POINTER*)
     MSCW = RECORD
	      STATLINK : integer; {MSCWP;}(*POINTER TO PARENT MSCW*)
	      DYNLINK  : integer; {MSCWP;}(*POINTER TO CALLER'S MSCW*)
	      MSJTAB   : integer; {^TRICKARRAY;}
	      MSSEG    : integer; {^TRICKARRAY;}
              MSIPC    : INTEGER;
	      LOCALDATA: TRICKARRAY
	    END (*MSCW*) ;

					(*SYSTEM COMMUNICATION AREA*)
					(*SEE INTERPRETERS...NOTE	*)
					(*THAT WE ASSUME BACKWARD	*)

					(*FIELD ALLOCATION IS DONE *)

{now syscom stuff}
     SYSCOMREC = RECORD

		   IORSLT  : integer; (*RESULT OF LAST IO CALL*)
		   XEQERR  : INTEGER; (*REASON FOR EXECERROR CALL*)
		   SYSUNIT : integer; (*PHYSICAL UNIT OF BOOTLOAD*)
		   BUGSTATE: INTEGER; (*DEBUGGER INFO*)
		   GDIRP   : word   ; (*GLOBAL DIR POINTER,SEE VOLSEARCH*)
		   BOMBP   : word   ;
                   STKBASE : word   ;
{14}               LASTMP  : word   ;
		   JTAB    : word ;
                   SEG     : word;
                   MEMTOP  : word;
		   BOMBIPC : word;    (*WHERE XEQERR BLOWUP WAS*)
		   HLTLINE : word;    (*MORE DEBUGGER STUFF*)
{26}               BRKPTS  : ARRAY [0..3] OF word   ;
{34}		   RETRIES : INTEGER; (*DRIVERS PUT RETRY COUNTS*)
{36}		   EXPANSION:ARRAY [0..8] OF INTEGER;
{54}		   LOTIME  : integer;
{56}               HITIME  : integer;
{58}		   MISCINFO: integer;
                                (* PACKED RECORD
				  NOBREAK,STUPID,SLOWTERM,
				  HASXYCRT,HASLCCRT,HAS8510A,HASCLOCK: BOOLEAN;
				  USERKIND:(NORMAL, AQUIZ, BOOKER, PQUIZ)
				END; *)
{60}		   CRTTYPE: INTEGER;
{62}		   CRTCTRL: PACKED RECORD
{62}				 ESCAPE  : CHAR;
{63}                             HOME    : char;
{64}                             ERASEEOS: char;
{65}                             ERASEEOL: char;
{66}                             NDFS    : char;
{67}                             RLF     : char;
{68}                             BACKSPACE: CHAR;
{69}				 FILLCOUNT: 0..255;
{70}				 EXPANSION: PACKED ARRAY [0..3] OF CHAR
			    END;
{74}		   CRTINFO: PACKED RECORD
{74}				 HEIGHT : INTEGER;
{76}                             WIDTH  : INTEGER;
{78}				 UP     : CHAR;
{79}                             DOWN   : char;
{80}                             LEFT   : char;
{81}                             RIGHT  : char;
{82}                             EOF    : CHAR;
{83}                             FLUSH  : char;
{84}                             BREAK  : char;
{85}                             STOP   : char;
{86}                             CHARDEL: char;
{87}                             BADCH  : char;
{88}				 LINEDEL: CHAR;
{89}                             ALTMODE: char;
{90}				 EXPANSION: PACKED ARRAY [0..5] OF CHAR
			    END;
{96}
                   (*
                    SEGTABLE: ARRAY [SEGRANGE] OF
			       RECORD
				 CODEUNIT: UNITNUM;
				 CODEDESC: SEGDESC
			       END;
                    *)

                   SEGTBL : array[0..MAXSEG] of
                              Record
                                CODEUNIT : Word; {UNITNUM;}
                                DISKADDR : Word;
                                CODELENG : Word;
                              end;

                   RELSEG : array[0..MAXSEG] of
                              Record
                                Diskaddr : Word;
                                Codelen  : Word;
                              end;
	END; (* SYSCOM*)

        SYSCOMPTR = ^SYSCOMREC;


var


{internal P-machine registers}
     NP     : word;        {^top of heap}
     MPD0   : word;        {^local var with offset zero}
     BASED0 : word;        {^global var with offset zero}
     IPSAV  : word;        {save IPC on complex ops and XEQERR}
     FPERROR: word;
     RETADR : word;
     NEWSP  : word;
     LTSTRNG: byte;
     crap1  : byte; {filler}

     {intsegt contains refcounts and addr of each seg} {.BLOCK 64}
     INTSEGT: array [ 0..Maxseg] of
                Record
                  REFCOUNT : Word;
                  SEGADDR  : Word;
                end;

     BYTE1  : word;

     SEGBOT : word;   {ptr to bottom of segment}
     RLBASE : word;   {base relocation amt}
     REFP   : word;   {pointer to relevant refcount}
     PROCBOT: word;   {pc relative (proc) relocation count}
     RLDELTA: word;   {relocation amt for current reloc}
     SEGNUM : word;   {segment # currently being called}
     xSEGTP : word;   {^segtable entry for segment}  {not used LB 28/3/97}
     NEWSEG : word;   { new SEGP}
     NEWJTB : word;   { new JTAB pointer}


{     SYSCOM : SYSCOMPTR;}{^SYSCOMREC}



{     MISCINFOREC = RECORD
		     MSYSCOM: SYSCOMREC
                   END;
}



(*

begin
  writeln('daterec = ',sizeof(daterec));
  writeln('unitnum = ',sizeof(unitnum));
  writeln('direntry= ',sizeof(direntry));
  writeln('syscom  = ',sizeof(syscomrec));
end.
*)

IMPLEMENTATION
Begin
end.