Unit WrtLinkr;   (* for DOS I.5 cross-compiler *)
interface
uses globals,
     procs;

{overlay} PROCEDURE WRITELINKERINFO(DECSTUFF:BOOLEAN);



implementation
    
    (******************************************************************)
    (*                                                                *)
    (*  Copyright (c) l978 Regents of the University of California.   *)
    (*  Permission to copy or distribute this software or documen-    *)
    (*  tation in hard or soft copy granted only by written license   *) 
    (*  obtained from the Institute for Information Systems.          *)
    (*                                                                *)
    (******************************************************************)
    
{overlay} PROCEDURE WRITELINKERINFO(DECSTUFF:BOOLEAN);
  TYPE
    LITYPES = (EOFMARK,MODDULE,GLOBREF,PUBBLIC,PRIVVATE,CONNSTANT,GLOBDEF,
               PUBLICDEF,CONSTDEF,EXTPROC,EXTFUNC,SSEPPROC,SSEPFUNC,
               SEPPREF,SEPFREF);
    OPFORMAT = (WORD, BYTE, BIG);
    LIENTRY = RECORD
                LINAME: ALPHA;
                CASE LITYPE: LITYPES OF
                  MODDULE,
                  PUBBLIC,
                  PRIVVATE,
                  SEPPREF,
                  SEPFREF:          (FORMAT: OPFORMAT;
                                     NREFS: INTEGER;
                                     NWORDS: INTEGER);
                  CONSTDEF:         (CONSTANT: INTEGER);
                  PUBLICDEF:        (BASEOFFSET: INTEGER);
                  EXTPROC,EXTFUNC,
                  SSEPPROC,SSEPFUNC:(PROCNUM: INTEGER;
                                     NPARAMS: INTEGER;
                                     {RANGE: ^INTEGER)}
                                     range : integer)  {patch /tp3}
              END;

  VAR FCP,LCP: CTP; CURRENTBLOCK: INTEGER; I: NONRESIDENT;
      EXTNAME: ALPHA; FIC: ADDRRANGE;
      LIREC: LIENTRY;
  
  PROCEDURE GETREFS(ID,LENGTH: INTEGER);
    VAR LIC: ADDRRANGE; J,MAX,BLOCKCOUNT,COUNT: INTEGER;
    
    PROCEDURE GETNEXTBLOCK;
    BEGIN
      CURRENTBLOCK := CURRENTBLOCK + 1;
      IF CURRENTBLOCK > REFBLK THEN CURRENTBLOCK := 0;
      IF ucsdBLOCKREADrel(REFFILE,REFLIST^,1,CURRENTBLOCK) <> 1 THEN;
    END (*GETNEXTBLOCK*) ;
    
  BEGIN (*GETREFS*)
    IF (NREFS = 1) AND (REFBLK = 0) THEN EXIT;{(GETREFS);}
    COUNT := 0; 
    FOR BLOCKCOUNT := 0 TO REFBLK DO
      BEGIN
        IF CURRENTBLOCK < REFBLK THEN MAX := REFSPERBLK ELSE MAX := NREFS-1;
        FOR J := 1 TO MAX DO
          IF ID = REFLIST^[J].KEY THEN
            BEGIN GENWORD(REFLIST^[J].OFFSET); COUNT := COUNT + 1 END;
        IF BLOCKCOUNT < REFBLK THEN GETNEXTBLOCK;
      END;
    LIC := IC; IC := FIC; GENWORD(COUNT); IC := LIC;
    (*NOW FILL REST OF 8-WORD RECORD*)
    FOR J := 1 TO ((8 - (COUNT MOD 8)) MOD 8) DO GENWORD(0)
  END (* GETREFS *) ;
            
  PROCEDURE GLOBALSEARCH(FCP: CTP);
    VAR NEEDEDBYLINKER: BOOLEAN;
    
  BEGIN
    NEEDEDBYLINKER := TRUE;
    WITH LIREC,FCP^ DO
      CASE KLASS OF
        TYPES: NEEDEDBYLINKER := FALSE;
        KONST: IF (IDTYPE^.SIZE = 1) AND NOT INMODULE THEN
                 BEGIN LITYPE := CONSTDEF;
                   CONSTANT := VALUES.IVAL
                 END
               ELSE NEEDEDBYLINKER := FALSE;
        FORMALVARS,
        ACTUALVARS:
               BEGIN
                 IF INMODULE THEN
                   BEGIN
                     IF PUBLIC THEN
                       BEGIN LITYPE := PUBBLIC;
                         NWORDS := 0
                       END
                     ELSE
                       BEGIN LITYPE := PRIVVATE;
                         IF KLASS = FORMALVARS THEN
                           NWORDS := PTRSIZE
                         ELSE
                           NWORDS := IDTYPE^.SIZE
                       END;
                     FORMAT := BIG
                   END
                 ELSE
                   BEGIN LITYPE := PUBLICDEF;
                     BASEOFFSET := VADDR
                   END
               END;
        FIELD: NEEDEDBYLINKER := FALSE;
        PROC,
        FUNC:  BEGIN
                 IF PFDECKIND = DECLARED THEN
                   IF PFKIND = ACTUAL THEN
                     IF KLASS = PROC THEN
                       IF EXTURNAL THEN
                         IF SEPPROC THEN LITYPE := SEPPREF
                         ELSE LITYPE := EXTPROC
                       ELSE
                         IF SEPPROC THEN
                           LITYPE := SSEPPROC
                         ELSE NEEDEDBYLINKER := FALSE
                     ELSE (*KLASS = FUNC*)
                       IF EXTURNAL THEN
                         IF SEPPROC THEN LITYPE := SEPFREF
                         ELSE LITYPE := EXTFUNC
                       ELSE
                         IF SEPPROC THEN
                           LITYPE := SSEPFUNC
                         ELSE NEEDEDBYLINKER := FALSE
                   ELSE NEEDEDBYLINKER := FALSE
                 ELSE NEEDEDBYLINKER := FALSE;
                 IF NEEDEDBYLINKER THEN
                   BEGIN
                     LCP := NEXT; NPARAMS := 0;
                     WHILE LCP <> pNIL DO
                       BEGIN
                         WITH LCP^ DO
                           IF KLASS = FORMALVARS THEN
                             NPARAMS := NPARAMS + PTRSIZE
                           ELSE
                             IF KLASS = ACTUALVARS THEN
                               IF IDTYPE^.FORM <= POWER THEN
                                 NPARAMS := NPARAMS + IDTYPE^.SIZE
                               ELSE NPARAMS := NPARAMS + PTRSIZE;
                         LCP := LCP^.NEXT
                       END;
                     IF LITYPE IN [SEPPREF,SEPFREF] THEN
                       BEGIN FORMAT := BYTE; NWORDS := NPARAMS END
                     ELSE
                       BEGIN PROCNUM := PFNAME; RANGE := 1 {pNIL} {patch /tp3}
                       END
                   END
                 END (*PROC,FUNC*);
        MODULE:  BEGIN
                   IF NOT INMODULE THEN NEEDEDBYLINKER := FALSE
                   ELSE
                     BEGIN LITYPE := MODDULE; NWORDS := 0; FORMAT := BYTE END
                 END
      END (*CASE,WITH*);
    IF NEEDEDBYLINKER THEN
      IF SEGTABLE[SEG].SEGKIND = 2 (*SEGPROC*) THEN
        WITH LIREC DO
          IF (LITYPE = CONSTDEF) OR (LITYPE = PUBLICDEF) THEN
            NEEDEDBYLINKER := FALSE;
    IF NEEDEDBYLINKER THEN
      WITH LIREC DO
        BEGIN LINAME := FCP^.NAME;
          FOR LGTH := 1 TO 8 DO GENBYTE(ORD(LINAME[LGTH]));
          GENWORD(ORD(LITYPE));
          CASE LITYPE OF
            MODDULE,
            PUBBLIC,
            PRIVVATE,
            SEPPREF,SEPFREF: BEGIN
                               GENWORD(ORD(FORMAT));
                               FIC := IC; GENWORD(0);
                               GENWORD(NWORDS);
                               IF LITYPE = MODDULE THEN GETREFS(FCP^.SEGID,1)
                               ELSE
                                IF LITYPE IN [SEPPREF,SEPFREF] THEN
                                  GETREFS(-FCP^.PFNAME,1)
                                ELSE GETREFS(FCP^.VADDR + 32,FCP^.IDTYPE^.SIZE);
                             END;
            CONSTDEF: BEGIN  GENWORD(CONSTANT); GENWORD(0); GENWORD(0) END;
            PUBLICDEF: BEGIN GENWORD(BASEOFFSET); GENWORD(0); GENWORD(0) END;
            EXTPROC,EXTFUNC:     BEGIN
                                   GENWORD(PROCNUM);
                                   GENWORD(NPARAMS);
                                   GENWORD(ORD(RANGE))
                                 END;
            SSEPPROC,SSEPFUNC:   BEGIN
                                   GENWORD(PROCNUM);
                                   GENWORD(NPARAMS);
                                   GENWORD(ORD(RANGE));
                                   FOR LGTH := 1 TO 8 DO
                                     GENBYTE(ORD(LINAME[LGTH]));
                                   IF LITYPE = SSEPPROC THEN 
                                     GENWORD(ORD(SEPPREF))
                                   ELSE GENWORD(ORD(SEPFREF));
                                   GENWORD(ORD(BYTE));
                                   FIC := IC; GENWORD(0); GENWORD(NPARAMS);
                                   GETREFS(-PROCNUM,1)
                                 END
          END(*CASE*)
        END(*WITH*);
    IF IC >= 1024 THEN BEGIN WRITECODE(TRUE); IC := 0 END;
    
    IF FCP^.LLINK <> pNIL THEN GLOBALSEARCH(FCP^.LLINK);
    IF FCP^.RLINK <> pNIL THEN GLOBALSEARCH(FCP^.RLINK)
  
  END (*GLOBALSEARCH*);

BEGIN (*WRITELINKERINFO*)
  IC := 0;
  IF CODEINSEG THEN ERROR(399);
  IF INMODULE THEN
      CURRENTBLOCK := REFBLK;
  IF DECSTUFF THEN (*SKIP IF NO DECLARATIONPART LINKER INFO*)
    BEGIN FCP := DISPLAY[GLEV].FNAME;
      IF FCP <> pNIL THEN GLOBALSEARCH(FCP)
    END;
  (*NOW DO NONRESIDENT PROCS*)
  WITH LIREC DO
    FOR I := fSEAK TO fDECOPS DO    {/tp5} {/pc157a}
      IF PFNUMOF[I] <> 0 THEN
        BEGIN
          CASE I OF
            fSEAK:      BEGIN LINAME := 'FSEEK   '; NPARAMS := 2 END; {/tp5}
            fFREADREAL: BEGIN LINAME := 'FREADREA'; NPARAMS := 2 END; {/tp5}
            fFWRITEREAL:BEGIN LINAME := 'FWRITERE'; NPARAMS := 5 END; {/tp5}
            fFREADDEC:  BEGIN LINAME := 'FREADDEC'; NPARAMS := 3 END; {/pc157a}
            fFWRITEDEC: BEGIN LINAME := 'FWRITEDE'; NPARAMS := 10 END;
            fDECOPS:    BEGIN LINAME := 'DECOPS  '; NPARAMS := 0 END;
          END;
          FOR LGTH := 1 TO 8 DO GENBYTE(ORD(LINAME[LGTH]));
          IF SEPPROC THEN
            BEGIN GENWORD(ORD(SEPPREF));
              GENWORD(ORD(BYTE)); FIC := IC; GENWORD(0); GENWORD(NPARAMS);
              GETREFS(-PFNUMOF[I],1)
            END
          ELSE
            BEGIN GENWORD(ORD(EXTPROC));
              GENWORD(PFNUMOF[I]); GENWORD(NPARAMS); GENWORD(0)
            END;
          PFNUMOF[I] := 0;
        END;
  (* NOW DO EOFMARK END-RECORD*)
  FOR LGTH := 1 TO 8 DO GENBYTE(ORD(' '));
  GENWORD(ORD(EOFMARK)); GENWORD(LCMAX);
  GENWORD(0);GENWORD(0);
  WRITECODE(TRUE);
  CLINKERINFO := FALSE;
  IF DECSTUFF THEN DLINKERINFO := FALSE
END (*WRITELINKERINFO*); 




end.